/*
   @C:\web_406\sql\end_conv\oracle\02CR_GERTRG_LOG_EST_CUSTOCMPPROD.SQL;
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_EST_CUSTOCMPPROD' AND
                 TYPE   = 'TR' 		             AND
	              U.UID  = O.UID                  AND
	              U.NAME = USER)
DROP TRIGGER LOG_EST_CUSTOCMPPROD
GO


CREATE TRIGGER LOG_EST_CUSTOCMPPROD
ON CUSTOCMPPROD
FOR INSERT, UPDATE, DELETE
AS

   DECLARE  @V_USUARIO      VARCHAR(40);
   DECLARE  @V_TIPO         VARCHAR(1);
   DECLARE  @V_ITPESQ       VARCHAR(40);
   DECLARE  @V_DESC         VARCHAR(300);
   DECLARE  @V_CDFILLOGOPER VARCHAR(4);
   DECLARE  @V_DTOPER       DATETIME;

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO     VARCHAR(1);

   DECLARE  @V_OLD_CDFILLANCEST VARCHAR(4);
   DECLARE  @V_OLD_VRLIQCMPPROD DOUBLE PRECISION;
   DECLARE  @V_OLD_VRLIQCMPPRM1 DOUBLE PRECISION;
   DECLARE  @V_OLD_VRLIQCMPPRM2 DOUBLE PRECISION;
   DECLARE  @V_OLD_VRBRUCMPPROD DOUBLE PRECISION;
   DECLARE  @V_OLD_VRBRUCMPPRM1 DOUBLE PRECISION;
   DECLARE  @V_OLD_VRBRUCMPPRM2 DOUBLE PRECISION;
   DECLARE  @V_OLD_CDFILIAL     VARCHAR(4);
   DECLARE  @V_OLD_CDALMOXARIFE VARCHAR(6);
   DECLARE  @V_OLD_CDLOCALESTOQ VARCHAR(8);
   DECLARE  @V_OLD_NRLOTEESTQ   VARCHAR(20);
   DECLARE  @V_OLD_NRSUBLOTE    VARCHAR(4);
   DECLARE  @V_OLD_CDPRODUTO    VARCHAR(10);
   DECLARE  @V_OLD_DTCUSTCMPPRO DATETIME;
   DECLARE  @V_OLD_NRLANCESTQ   VARCHAR(10);
   DECLARE  @V_NEW_CDFILLANCEST VARCHAR(4);
   DECLARE  @V_NEW_VRLIQCMPPROD DOUBLE PRECISION;
   DECLARE  @V_NEW_VRLIQCMPPRM1 DOUBLE PRECISION;
   DECLARE  @V_NEW_VRLIQCMPPRM2 DOUBLE PRECISION;
   DECLARE  @V_NEW_VRBRUCMPPROD DOUBLE PRECISION;
   DECLARE  @V_NEW_VRBRUCMPPRM1 DOUBLE PRECISION;
   DECLARE  @V_NEW_VRBRUCMPPRM2 DOUBLE PRECISION;
   DECLARE  @V_NEW_CDFILIAL     VARCHAR(4);
   DECLARE  @V_NEW_CDALMOXARIFE VARCHAR(6);
   DECLARE  @V_NEW_CDLOCALESTOQ VARCHAR(8);
   DECLARE  @V_NEW_NRLOTEESTQ   VARCHAR(20);
   DECLARE  @V_NEW_NRSUBLOTE    VARCHAR(4);
   DECLARE  @V_NEW_CDPRODUTO    VARCHAR(10);
   DECLARE  @V_NEW_DTCUSTCMPPRO DATETIME;
   DECLARE  @V_NEW_NRLANCESTQ   VARCHAR(10);
BEGIN
   SET @V_TIPO         = '0';
   SET @V_DESC         = '';
   SET @V_CDFILLOGOPER = '';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
     'D' IDCOMANDO,
         CDFILLANCEST,
         VRLIQCMPPROD,
         VRLIQCMPPRM1,
         VRLIQCMPPRM2,
         VRBRUCMPPROD,
         VRBRUCMPPRM1,
         VRBRUCMPPRM2,
         CDFILIAL,
         CDALMOXARIFE,
         CDLOCALESTOQ,
         NRLOTEESTQ,
         NRSUBLOTE,
         CDPRODUTO,
         DTCUSTCMPPRO,
         NRLANCESTQ,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
   FROM
      DELETED
   WHERE
      (CDFILIAL+CDALMOXARIFE+CDLOCALESTOQ+NRLOTEESTQ+NRSUBLOTE+CDPRODUTO+CONVERT(VARCHAR, DTCUSTCMPPRO)) NOT IN (SELECT
                                                                                                                 CDFILIAL+
                                                                                                                 CDALMOXARIFE+
                                                                                                                 CDLOCALESTOQ+
                                                                                                                 NRLOTEESTQ+
                                                                                                                 NRSUBLOTE+
                                                                                                                 CDPRODUTO+
                                                                                                                 CONVERT(VARCHAR, DTCUSTCMPPRO)
                                                                                                                 FROM INSERTED)

   UNION ALL
   SELECT
     'U' IDCOMANDO,
         DELETED.CDFILLANCEST,
         DELETED.VRLIQCMPPROD,
         DELETED.VRLIQCMPPRM1,
         DELETED.VRLIQCMPPRM2,
         DELETED.VRBRUCMPPROD,
         DELETED.VRBRUCMPPRM1,
         DELETED.VRBRUCMPPRM2,
         DELETED.CDFILIAL,
         DELETED.CDALMOXARIFE,
         DELETED.CDLOCALESTOQ,
         DELETED.NRLOTEESTQ,
         DELETED.NRSUBLOTE,
         DELETED.CDPRODUTO,
         DELETED.DTCUSTCMPPRO,
         DELETED.NRLANCESTQ,

         INSERTED.CDFILLANCEST,
         INSERTED.VRLIQCMPPROD,
         INSERTED.VRLIQCMPPRM1,
         INSERTED.VRLIQCMPPRM2,
         INSERTED.VRBRUCMPPROD,
         INSERTED.VRBRUCMPPRM1,
         INSERTED.VRBRUCMPPRM2,
         INSERTED.CDFILIAL,
         INSERTED.CDALMOXARIFE,
         INSERTED.CDLOCALESTOQ,
         INSERTED.NRLOTEESTQ,
         INSERTED.NRSUBLOTE,
         INSERTED.CDPRODUTO,
         INSERTED.DTCUSTCMPPRO,
         INSERTED.NRLANCESTQ
   FROM
      DELETED,
      INSERTED
   WHERE
      INSERTED.CDFILIAL     = DELETED.CDFILIAL        AND
      INSERTED.CDALMOXARIFE = DELETED.CDALMOXARIFE    AND
      INSERTED.CDLOCALESTOQ = DELETED.CDLOCALESTOQ    AND
      INSERTED.NRLOTEESTQ   = DELETED.NRLOTEESTQ      AND
      INSERTED.NRSUBLOTE    = DELETED.NRSUBLOTE       AND
      INSERTED.CDPRODUTO    = DELETED.CDPRODUTO       AND
      INSERTED.DTCUSTCMPPRO = DELETED.DTCUSTCMPPRO

   UNION ALL

   SELECT
     'I' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         CDFILLANCEST,
         VRLIQCMPPROD,
         VRLIQCMPPRM1,
         VRLIQCMPPRM2,
         VRBRUCMPPROD,
         VRBRUCMPPRM1,
         VRBRUCMPPRM2,
         CDFILIAL,
         CDALMOXARIFE,
         CDLOCALESTOQ,
         NRLOTEESTQ,
         NRSUBLOTE,
         CDPRODUTO,
         DTCUSTCMPPRO,
         NRLANCESTQ
   FROM
      INSERTED
   WHERE
      (CDFILIAL+CDALMOXARIFE+CDLOCALESTOQ+NRLOTEESTQ+NRSUBLOTE+CDPRODUTO+CONVERT(VARCHAR, DTCUSTCMPPRO)) NOT IN (SELECT
                                                                                                                 CDFILIAL+
                                                                                                                 CDALMOXARIFE+
                                                                                                                 CDLOCALESTOQ+
                                                                                                                 NRLOTEESTQ+
                                                                                                                 NRSUBLOTE+
                                                                                                                 CDPRODUTO+
                                                                                                                 CONVERT(VARCHAR, DTCUSTCMPPRO)
                                                                                                                 FROM DELETED);

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_OLD_CDFILLANCEST,
                                 @V_OLD_VRLIQCMPPROD,
                                 @V_OLD_VRLIQCMPPRM1,
                                 @V_OLD_VRLIQCMPPRM2,
                                 @V_OLD_VRBRUCMPPROD,
                                 @V_OLD_VRBRUCMPPRM1,
                                 @V_OLD_VRBRUCMPPRM2,
                                 @V_OLD_CDFILIAL,
                                 @V_OLD_CDALMOXARIFE,
                                 @V_OLD_CDLOCALESTOQ,
                                 @V_OLD_NRLOTEESTQ,
                                 @V_OLD_NRSUBLOTE,
                                 @V_OLD_CDPRODUTO,
                                 @V_OLD_DTCUSTCMPPRO,
                                 @V_OLD_NRLANCESTQ,

                                 @V_NEW_CDFILLANCEST,
                                 @V_NEW_VRLIQCMPPROD,
                                 @V_NEW_VRLIQCMPPRM1,
                                 @V_NEW_VRLIQCMPPRM2,
                                 @V_NEW_VRBRUCMPPROD,
                                 @V_NEW_VRBRUCMPPRM1,
                                 @V_NEW_VRBRUCMPPRM2,
                                 @V_NEW_CDFILIAL,
                                 @V_NEW_CDALMOXARIFE,
                                 @V_NEW_CDLOCALESTOQ,
                                 @V_NEW_NRLOTEESTQ,
                                 @V_NEW_NRSUBLOTE,
                                 @V_NEW_CDPRODUTO,
                                 @V_NEW_DTCUSTCMPPRO,
                                 @V_NEW_NRLANCESTQ;



   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN
         SET @V_TIPO = '3';
         SET @V_ITPESQ       = @V_OLD_CDFILIAL+@V_OLD_CDALMOXARIFE+@V_OLD_CDLOCALESTOQ+@V_OLD_NRLOTEESTQ+@V_OLD_NRSUBLOTE+
                               @V_OLD_CDPRODUTO+CONVERT(VARCHAR, @V_OLD_DTCUSTCMPPRO);
         IF @V_OLD_CDFILIAL IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'Filial=' + @V_OLD_CDFILIAL;
         END;
         IF @V_OLD_CDALMOXARIFE IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Almox=' + @V_OLD_CDALMOXARIFE;
         END;
         IF @V_OLD_CDLOCALESTOQ IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Local=' + @V_OLD_CDLOCALESTOQ;
         END;
         IF @V_OLD_NRLOTEESTQ IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Lote=' +  @V_OLD_NRLOTEESTQ;
         END;
         IF @V_OLD_NRSUBLOTE IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' SubLote=' + @V_OLD_NRSUBLOTE;
         END;
         IF @V_OLD_CDPRODUTO IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Prod=' + @V_OLD_CDPRODUTO;
         END;

         IF @V_OLD_DTCUSTCMPPRO IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Data=' + CONVERT(VARCHAR, @V_OLD_DTCUSTCMPPRO);
         END;
         IF @V_OLD_CDFILLANCEST IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' FilLanc=' + @V_OLD_CDFILLANCEST;
         END;

         IF @V_OLD_NRLANCESTQ IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Lanc=' + @V_OLD_NRLANCESTQ;
         END;

         IF @V_OLD_VRLIQCMPPROD IS NOT NULL BEGIN
            SET  @V_DESC = @V_DESC + ' VrLiq=' + CONVERT(VARCHAR,@V_OLD_VRLIQCMPPROD);
         END;

         IF @V_OLD_VRBRUCMPPROD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' VrBrut=' + CONVERT(VARCHAR,@V_OLD_VRBRUCMPPROD);
         END;
      END
      ELSE BEGIN
         IF @V_ID_COMANDO= 'U' /*UPDATING*/ BEGIN
            IF (@V_OLD_CDFILLANCEST <> @V_NEW_CDFILLANCEST)     OR
               (@V_OLD_VRLIQCMPPROD <> @V_NEW_VRLIQCMPPROD)     OR
               (@V_OLD_VRLIQCMPPRM1 <> @V_NEW_VRLIQCMPPRM1)     OR
               (@V_OLD_VRLIQCMPPRM2 <> @V_NEW_VRLIQCMPPRM2)     OR
               (@V_OLD_VRBRUCMPPROD <> @V_NEW_VRBRUCMPPROD)     OR
               (@V_OLD_VRBRUCMPPRM1 <> @V_NEW_VRBRUCMPPRM1)     OR
               (@V_OLD_VRBRUCMPPRM2 <> @V_NEW_VRBRUCMPPRM2) BEGIN

               SET @V_TIPO         = '2';
               SET @V_ITPESQ       = @V_OLD_CDFILIAL+@V_OLD_CDALMOXARIFE+@V_OLD_CDLOCALESTOQ+@V_OLD_NRLOTEESTQ+@V_OLD_NRSUBLOTE+
                                     @V_OLD_CDPRODUTO+CONVERT(VARCHAR, @V_OLD_DTCUSTCMPPRO);
               SET @V_CDFILLOGOPER = @V_OLD_CDFILIAL;
            END;
            IF @V_NEW_CDFILIAL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Filial=' + @V_NEW_CDFILIAL;
            END;
            IF @V_NEW_CDALMOXARIFE IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Almox=' + @V_NEW_CDALMOXARIFE;
            END;
            IF @V_NEW_CDLOCALESTOQ IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Local=' + @V_NEW_CDLOCALESTOQ;
            END;
            IF @V_NEW_NRLOTEESTQ IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Lote=' +  @V_NEW_NRLOTEESTQ;
            END;
            IF @V_NEW_NRSUBLOTE IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' SubLote=' + @V_NEW_NRSUBLOTE;
            END;
            IF @V_NEW_CDPRODUTO IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Prod=' + @V_NEW_CDPRODUTO;
            END;
            IF @V_NEW_DTCUSTCMPPRO IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Data=' + CONVERT(VARCHAR, @V_NEW_DTCUSTCMPPRO);
            END;
            IF @V_NEW_CDFILLANCEST IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' FilLanc=' + @V_NEW_CDFILLANCEST;
            END;
            IF @V_NEW_NRLANCESTQ IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Lanc=' + @V_NEW_NRLANCESTQ;
            END;
            IF @V_NEW_VRLIQCMPPROD IS NOT NULL BEGIN
              SET  @V_DESC = @V_DESC + ' VrLiq=' + CONVERT(VARCHAR, @V_NEW_VRLIQCMPPROD);
            END;
            IF @V_NEW_VRBRUCMPPROD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' VrBrut=' + CONVERT(VARCHAR, @V_NEW_VRBRUCMPPROD);
            END;
         END
         ELSE BEGIN
            SET @V_TIPO         = '1';
            SET @V_ITPESQ       = @V_NEW_CDFILIAL+@V_NEW_CDALMOXARIFE+@V_NEW_CDLOCALESTOQ+@V_NEW_NRLOTEESTQ+@V_NEW_NRSUBLOTE+
                                  @V_NEW_CDPRODUTO+CONVERT(VARCHAR, @V_NEW_DTCUSTCMPPRO);
            SET @V_CDFILLOGOPER = @V_NEW_CDFILIAL;
            IF @V_NEW_CDFILIAL IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + 'Filial=' + @V_NEW_CDFILIAL;
            END;
            IF @V_NEW_CDALMOXARIFE IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Almox=' + @V_NEW_CDALMOXARIFE;
            END;
            IF @V_NEW_CDLOCALESTOQ IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Local=' + @V_NEW_CDLOCALESTOQ;
            END;
            IF @V_NEW_NRLOTEESTQ IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Lote=' +  @V_NEW_NRLOTEESTQ;
            END;
            IF @V_NEW_NRSUBLOTE IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' SubLote=' + @V_NEW_NRSUBLOTE;
            END;
            IF @V_NEW_CDPRODUTO IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Prod=' + @V_NEW_CDPRODUTO;
            END;
            IF @V_NEW_DTCUSTCMPPRO IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Data=' + CONVERT(VARCHAR, @V_NEW_DTCUSTCMPPRO);
            END;
            IF @V_NEW_CDFILLANCEST IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' FilLanc=' + @V_NEW_CDFILLANCEST;
            END;
            IF @V_NEW_NRLANCESTQ IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Lanc=' + @V_NEW_NRLANCESTQ;
            END;
            IF @V_NEW_VRLIQCMPPROD IS NOT NULL BEGIN
               SET  @V_DESC = @V_DESC + ' VrLiq=' + CONVERT(VARCHAR,@V_NEW_VRLIQCMPPROD);
            END;
            IF @V_NEW_VRBRUCMPPROD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' VrBrut=' + CONVERT(VARCHAR,@V_NEW_VRBRUCMPPROD);
            END;

         END;
      END;

      IF @V_TIPO <> '0' BEGIN
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();
               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO, CDFILLOGOPER)
               VALUES
                  ('CUSTOCMPPROD',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO,    @V_ITPESQ, @V_DESC, @V_CDFILLOGOPER);
            END;
         END;
      END;

      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_OLD_CDFILLANCEST,
                                 @V_OLD_VRLIQCMPPROD,
                                 @V_OLD_VRLIQCMPPRM1,
                                 @V_OLD_VRLIQCMPPRM2,
                                 @V_OLD_VRBRUCMPPROD,
                                 @V_OLD_VRBRUCMPPRM1,
                                 @V_OLD_VRBRUCMPPRM2,
                    	      		@V_OLD_CDFILIAL,
                  			   	@V_OLD_CDALMOXARIFE,
                     			   @V_OLD_CDLOCALESTOQ,
                                 @V_OLD_NRLOTEESTQ,
                                 @V_OLD_NRSUBLOTE,
                                 @V_OLD_CDPRODUTO,
                                 @V_OLD_DTCUSTCMPPRO,
                                 @V_OLD_NRLANCESTQ,

                                 @V_NEW_CDFILLANCEST,
                                 @V_NEW_VRLIQCMPPROD,
                                 @V_NEW_VRLIQCMPPRM1,
                                 @V_NEW_VRLIQCMPPRM2,
                                 @V_NEW_VRBRUCMPPROD,
                                 @V_NEW_VRBRUCMPPRM1,
                                 @V_NEW_VRBRUCMPPRM2,
                                 @V_NEW_CDFILIAL,
                                 @V_NEW_CDALMOXARIFE,
                                 @V_NEW_CDLOCALESTOQ,
                                 @V_NEW_NRLOTEESTQ,
                                 @V_NEW_NRSUBLOTE,
                                 @V_NEW_CDPRODUTO,
                                 @V_NEW_DTCUSTCMPPRO,
                                 @V_NEW_NRLANCESTQ;





   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_EST_CUSTOCMPPROD','4.11.105';
GO
