/* Sistemas Integrados TECNISA
   Servios

Nome: 2868_PEDFUNO_PEDPRECO_PROD.SQL 

Descrio:
   Traz o custo da composio do produto verificando se o sistema esta
   trabalhando com tabela de preos ou fator de converso.

Criao:
12/12/07 - Welbert G. Moitinha */


IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'PEDPRECO_PROD' AND
                 TYPE = 'FN' 		      AND
	              U.UID = O.UID           AND
	              U.NAME = USER)
DROP FUNCTION PEDPRECO_PROD
GO

CREATE FUNCTION PEDPRECO_PROD ( @P_CDPRODUTO   VARCHAR(10),
                                @P_CDFILIAL    VARCHAR(4),
                                @P_CDPRECOBASE VARCHAR(2),
                                @P_CDFATPRECO  VARCHAR(3),
                                @P_DTATUAL     DATETIME )RETURNS DOUBLE PRECISION

AS
BEGIN
   DECLARE @V_IDTABPRECO  VARCHAR(1);
   DECLARE @V_VRPRECOPROD DOUBLE PRECISION;
   DECLARE @V_IDCUSEXP    VARCHAR(2);

   SET @V_VRPRECOPROD = 0;

   SELECT @V_IDTABPRECO = P.IDTABPRECO, @V_IDCUSEXP = ISNULL(E.IDCUSEXP,'')
   FROM PARAMPEDIDO P, PAREXPEDICAO E
   WHERE
      P.CDFILIAL = @P_CDFILIAL
      AND E.CDFILIAL = @P_CDFILIAL;



   IF  @V_IDTABPRECO IS NOT NULL  BEGIN
      IF @V_IDTABPRECO = '1' BEGIN
         SELECT
            @V_VRPRECOPROD = VRITEPREBASE

         FROM ITEMPREBASE
         WHERE
             CDPRECOBASE = @P_CDPRECOBASE
             AND CDPRODUTO = @P_CDPRODUTO
             AND DTINIVALIPB <= @P_DTATUAL
             AND ISNULL(DTFIMVALIPB, @P_DTATUAL + 1000) > @P_DTATUAL;
      END
      ELSE BEGIN
         SELECT            
/*custo de estoque ou preo de cotao*/

            @V_VRPRECOPROD=  CASE ISNULL((TEKNISA.CUSTO_PRODUTO_LCEST( @P_CDFILIAL, @P_CDPRODUTO, @V_IDCUSEXP,
                                        @P_DTATUAL, @P_DTATUAL,  TEKNISA.BUSCA_ALMOX( @P_CDFILIAL, '', @P_CDPRODUTO),
                                        TEKNISA.BUSCA_LOCAL( @P_CDFILIAL, '', @P_CDPRODUTO),' ',' ') * PR.VRFATOCONV) * F.VRFATPRECO,0) WHEN 0
                                        THEN
                                        ISNULL((TEKNISA.CUSTO_PRODUTO_LCEST( @P_CDFILIAL, @P_CDPRODUTO, 6,
                                        @P_DTATUAL, @P_DTATUAL,  TEKNISA.BUSCA_ALMOX( @P_CDFILIAL, '', @P_CDPRODUTO),
                                        TEKNISA.BUSCA_LOCAL( @P_CDFILIAL, '', @P_CDPRODUTO),' ',' ') * PR.VRFATOCONV) * F.VRFATPRECO,0)
                                        ELSE
                                        ISNULL((TEKNISA.CUSTO_PRODUTO_LCEST( @P_CDFILIAL, @P_CDPRODUTO, @V_IDCUSEXP,
                                        @P_DTATUAL, @P_DTATUAL,  TEKNISA.BUSCA_ALMOX( @P_CDFILIAL, '', @P_CDPRODUTO),
                                        TEKNISA.BUSCA_LOCAL( @P_CDFILIAL, '', @P_CDPRODUTO),' ',' ') * PR.VRFATOCONV) * F.VRFATPRECO,0) END
         FROM
            PRODFATOR F, PRODUTO PR
         WHERE
            F.CDFATPRECO     = @P_CDFATPRECO
            AND PR.CDPRODUTO = @P_CDPRODUTO
            AND F.CDPRODUTO  = PR.CDPRODUTO;
      END;
   END;
   RETURN(@V_VRPRECOPROD);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'PEDPRECO_PROD','5.05.004';
GO

