/******************************************************************************/
/* Sistemas Integrados TECNISA                                                */
/*                                                                            */
/* FAI - Faturamento de Alimentao Industrial                                */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/* Nome: 6600_FAITRGS_EXCLUSO_SERVCLIETURN                                   */
/*                                                                            */
/* Descrio:                                                                 */
/* Funcionar como se fosse o cascade, excluindo registros da tabela          */
/* SERVCLIETURN.                                                              */
/* Criao:                                                                   */
/* 14/02/2007 - Pedro Nerino Viol de Lima                                     */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'EXCLUSO_SERVCLIETURN' and
            type = 'TR'                      and
            u.uid = o.uid                    and
            u.name = USER)
DROP TRIGGER EXCLUSO_SERVCLIETURN
GO

CREATE TRIGGER EXCLUSO_SERVCLIETURN
ON TURNOSERV
FOR DELETE

AS


   DECLARE @V_OLDCDFILIAL   VARCHAR(4);
   DECLARE @V_OLDCDSERVFILI VARCHAR(5);
   DECLARE @V_OLDCDTURNO    VARCHAR(1);

BEGIN
   DECLARE C_DADOS CURSOR FOR
      SELECT
          CDFILIAL,
          CDSERVFILI,
          CDTURNO
      FROM
        DELETED
      WHERE
        0 = (SELECT COUNT(*) FROM INSERTED);
   OPEN C_DADOS;
   FETCH NEXT FROM C_DADOS INTO @V_OLDCDFILIAL,
                                @V_OLDCDSERVFILI,
                                @V_OLDCDTURNO;

   WHILE @@FETCH_STATUS = 0 BEGIN
      DELETE FROM
         SERVCLIETURN
      WHERE
         CDFILIAL   = @V_OLDCDFILIAL   AND
         CDSERVFILI = @V_OLDCDSERVFILI AND
         CDTURNO    = @V_OLDCDTURNO;

      FETCH NEXT FROM C_DADOS INTO @V_OLDCDFILIAL,
                                   @V_OLDCDSERVFILI,
                                   @V_OLDCDTURNO;

   END;
   CLOSE      C_DADOS;
   DEALLOCATE C_DADOS;
END;

-- VERSAO --
EXEC ATUVEROBJ 'EXCLUSO_SERVCLIETURN','4.11.069';
GO

